;; -*-emacs-lisp-*-
;;
;; Emacs startup file for the Debian GNU/Linux lpc-mode package
;;
;; Originally contributed by Nils Naumann <naumann@unileoben.ac.at>
;; Modified by Dirk Eddelbuettel <edd@debian.org>
;; Adapted for dh-make by Jim Van Zandt <jrv@vanzandt.mv.com>

;; The lpc-mode package follows the Debian/GNU Linux 'emacsen' policy and
;; byte-compiles its elisp files for each 'emacs flavor' (emacs19,
;; xemacs19, emacs20, xemacs20...).  The compiled code is then
;; installed in a subdirectory of the respective site-lisp directory.
;; We have to add this to the load-path:
(setq load-path (cons (concat "/usr/share/"
                              (symbol-name flavor)
			      "/site-lisp/lpc-mode") load-path))

(autoload 'lpc-mode "lpc-mode" "LPC mode" t)

(setq auto-mode-alist  (cons '("\\.lpc\\'" . lpc-mode) auto-mode-alist))
(setq auto-mode-alist  (cons '("\\.LPC\\'" . lpc-mode) auto-mode-alist))

;; LPC files often just have a '.c' extension. Do some guesswork:
;; For now, if we find an
;;    inherit "/some/path";
;; OR
;;    mapping variable_name; 
;; we'll guess at an LPC file.

(defun lpc-maybe-lpc-file ()
  (if (not (eq major-mode 'c-mode)) nil ;noop
    (save-excursion
      (let (stop)
	(goto-char (point-min))
	(forward-line 10)
	(setq stop (point))
	(goto-char (point-min))
	(or 
	 (re-search-forward "^\\s-*inherit\\s-+\"\\(/[^/]+\\)+\"\\s-*;" stop t)
	 (re-search-forward "^\\s-*mapping\\s-+\\w+\\>"                 nil  t)
	 )
	)
      )
    )
  )

(defun lpc-c-lpc-fun () (if (lpc-maybe-lpc-file) (lpc-mode)))

(setq after-load-alist 
      (cons (list "cc-vars" '(add-hook 'c-mode-common-hook 'lpc-c-lpc-fun))
	    after-load-alist))

